package com.zd.chemical.mapper;

import java.util.List;

import com.zd.chemical.domain.HxpCabinet;
import com.zd.chemical.domain.vo.*;
import com.zd.system.api.laboratory.CabinetV2Lock;
import org.apache.ibatis.annotations.Param;

/**
 * 化学品机柜管理信息Mapper接口
 *
 * @author liubo
 * @date 2022-06-16
 */
public interface HxpCabinetMapper
{
    /**
     * 查询化学品机柜管理信息
     *
     * @param id 化学品机柜管理信息主键
     * @return 化学品机柜管理信息
     */
    public HxpCabinet selectHxpCabinetById(Long id);

    /**
     * 查询化学品机柜管理信息
     *
     * @param cabinetNum 化学品机柜管理信息主键
     * @return 化学品机柜管理信息
     */
    public HxpCabinet selectHxpCabinetMaxById(String cabinetNum);

    /**
     * 查询化学品机柜管理信息列表
     *
     * @param hxpCabinetSearch 化学品机柜管理信息
     * @return 化学品机柜管理信息集合
     */
    public List<HxpCabinetVo> selectHxpCabinetList(HxpCabinetSearch hxpCabinetSearch);

    /**
     * 新增化学品机柜管理信息
     *
     * @param hxpCabinet 化学品机柜管理信息
     * @return 结果
     */
    public int insertHxpCabinet(HxpCabinet hxpCabinet);

    /**
     * 修改化学品机柜管理信息
     *
     * @param hxpCabinet 化学品机柜管理信息
     * @return 结果
     */
    public int updateHxpCabinet(HxpCabinet hxpCabinet);

    /**
     * 删除化学品机柜管理信息
     *
     * @param id 化学品机柜管理信息主键
     * @return 结果
     */
    public int deleteHxpCabinetById(Long id);

    /**
     * 批量删除化学品机柜管理信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHxpCabinetByIds(Long[] ids);


    /**
     * 查询机柜关联化学品数据统计列表
     *
     * @param hxpCabinetSearch 化学品机柜管理信息
     * @return 化学品机柜管理信息集合
     */
    public List<HxpCabinetInclusionChemicalVo> getCabinetByChemical(HxpCabinetSearch hxpCabinetSearch);

    /**
     * 查询机柜关联化学品数据详细列表
     *
     * @param cabinetInclusionChemicalVo 化学品机柜管理信息
     * @return 化学品机柜管理信息集合
     */
    public List<HxpCabinetInclusionChemicalSon> getCabinetByChemicalDetail(HxpCabinetInclusionChemicalVo cabinetInclusionChemicalVo);

    List<AioCabinetLockVo> queryCabinetLockList(AioCabinetLockVo aioCabinetLockVo);

    AioSubInfoVo querySubInfo(Long subId);

    Integer selectLockIdByJoinId(Long joinId);

    CabinetV2Lock selectByJoinId(Long lockId);

    CabinetV2Lock selectIpAddressByLockId(@Param("subId") Long subId, @Param("lockId") Integer lockId);
}
